<?php

class NetworkFirewall extends Model
{
  function __construct($Database, $System)
  {
    parent::__construct($Database, $System);
    $this->Name = 'NetworkFirewall';
    $this->AddPropertyOneToMany('NetworkDevice', 'NetworkDevice');
    $this->AddPropertyString('SourceInterface');
    $this->AddPropertyString('DestinationInterface');
    $this->AddPropertyString('SourceAddress');
    $this->AddPropertyString('DestinationAddress');
    $this->AddPropertyInteger('SourcePort');
    $this->AddPropertyInteger('DestinationPort');
    $this->AddPropertyString('Action');
    $this->AddPropertyString('Comment');
  }
}

class NetworkMark extends Model
{
  function __construct($Database, $System)
  {
    parent::__construct($Database, $System);
    $this->Name = 'NetworkMark';
    $this->AddPropertyString('Comment');
  }
}

class NetworkMangleSubgroup extends Model
{
  function __construct($Database, $System)
  {
    parent::__construct($Database, $System);
    $this->Name = 'NetworkMangleSubgroup';
    $this->AddPropertyString('AddressRange');
  }
}

class ModuleNetworkConfigRouterOS extends Module
{
  function __construct($Database, $System)
  {
    parent::__construct($Database, $System);
    $this->Name = 'NetworkConfigRouterOS';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPL';
    $this->Description = 'Mikrotik RouterOS configuration';
    $this->Dependencies = array('NetworkConfig');
    $this->SupportedModels = array('NetworkFirewall', 'NetworkMark', 
      'NetworkMangeSubgroup');
  }
  
  function Install()
  {
    parent::Install();
  }
  
  function UnInstall()
  {
    parent::UnInstall();
  }

  function Init()
  {
  }
}

?>
